
TACHYON
: 1WIRE.fth        ." 1-wire interface 120921:0000 " ;
{
The 1-Wire interface is implemented in bytecode so it does not require a special cog to handle the timing. Testing is being done on DS1820+ and DS2450S+ chips.
CHANGELOG:
}
( I/O DEFINITIONS )
#P7        |< CONSTANT #DQ

: 1WRESET ( -- ack )        
        #DQ OUTCLR 1 ms #DQ INPUTS
         #80 us
         #DQ IN 0=
         #400 us
         ;
pub 1WBIT! ( bit -- )
         IF #DQ DUP OUTCLR OUTSET #60 us
         ELSE
         #DQ DUP OUTCLR #80 us OUTSET
         THEN
        #DQ INPUTS
         ;               
\ Transmit 8-bit lsb first
pub 1W! ( dat -- )
        8 0 DO DUP 1 AND 1WBIT! 2/ LOOP DROP
        ;
pub 1WBIT@ ( -- bit )
        #DQ DUP OUTCLR INPUTS
         8 us
        #DQ IN
         ;
pub 1W@ ( -- dat )
        0 8
           FOR 2*
  1WBIT@
            IF 1+ THEN
          #40 us
          NEXT
        ;

pub READROM
        $33 1W!
        8 FOR 1W@ .BYTE SPACE NEXT
        ;
: BITS ( data -- bits ) 0 SWAP BEGIN DUP 1 AND IF SWAP 1+ SWAP THEN 2/ DUP 0= UNTIL DROP ;
: ODD?        BITS 1 AND 0<> ;
LONG        lastUnknown,dataMax,dataPtr,dataCnt,searchBit,unknown
LONG        addrL,addrH,addr,searchMask
pri NextBit
           1WBIT@ 1WBIT@ 2* +                                                                \ 2 bits A & B  
          DUP $202 .NUM SPACE
          DUP 3 = IF DROP dataCnt @ R> DROP EXIT THEN                                \ 11 - no devices responding
          DUP 2 = IF DROP addr @ searchMask @ ANDN EXIT THEN                         \ 10 - all devices have 0 bit
          DUP 1 = IF DROP addr DUP @ searchMask @ OR SWAP ! EXIT THEN         \ 01 - all devices have 1 bit
                                                                                                  \ 00 - device conflict
          searchBit @ lastUnknown @
  = IF searchMask @ addr @ OR addr ! EXIT THEN
  searchBit @ lastUnknown @
  > IF addr @ searchMask @ ANDN addr ! searchBit @ unknown ! EXIT THEN
          addr @ searchMask @ AND 0= IF searchBit @ unknown ! THEN
          ;
pri SendBit
        addr @ searchMask @ AND ODD?                \ send reply bit
        1WBIT!
        1 searchBit +!                                        \ increment search count
        searchMask @ 1 ROL searchMask !                \ adjust mask
        searchBit @ #33 =
          IF addr @ addrL !
          addrH @ addr !
          THEN
        ;
pub SEARCHROM ( table, max, family, -- addresses_found )
        addrL ! addrH ~
        2DUP 4 * ERASE
        lastUnknown ~
        DUP IF 7 lastUnknown ! THEN
        #150 MIN dataMax !
dataPtr ! dataCnt ~
( NEXTADDR )
          BEGIN
          1WRESET
          WHILE
          1 searchBit !
          unknown ~
          addrL @ addr !                \ get address bits
          1 searchMask !                \ Set search mask
          $F0 1W!                                \ Search ROM command
          CR ." Search ROM "
    BEGIN
    NextBit    
    SendBit
            searchBit @ #64 =
          UNTIL
          REPEAT
        CR addrH @ .LONG SPACE addrL @ .LONG
addrL @ dataPtr @ !
4 dataPtr +!
addrH @ dataPtr @ !
1 dataCnt +!                                        \ increment address count
      dataCnt @ dataMax @ =>
        unknown @ DUP lastUnknown ! 0=
        AND
        UNTIL ( nextAddr )                                \ repeat if more addresses
        dataCnt @                                                \ return number of addresses found
;
{
TABLE serialnums $100 ALLOT
serialnums #32 0 SEARCHROM
}

{
To check the ROM of a single device:
1WRESET DROP READROM
}

END

TACHYON

: 1WIREbbr.fth        ." 1-wire interface BBR additions 121018:0000 " 



: RD1ROM	( -- ) 1WRESET DROP READROM ;

: SKIPROM   ( -- )	$CC 1W! ;	\ when only one device online reSponds without MATCHROM

: MATCHROM   ( -- )	$55 1W! ;	\ command to match an ID to a specific device

: CONVERTT	( -- )	$44 1W! ;	\ commands all Temp sensors to start measurement (750 ms)

: READSCR	( -- )	$BE	1W!	;	\ dumps 9 bytes (8 plus CRC) of device scratchpad

: GETTEMP	 ( -- temp )			
					READSCR	
					1W@ 1W@ 8 SHL OR DUP
					$0F AND SWAP 4 SHR
					;
					
: PRINTTEMP	  ( bin-bits units -- )
		
					$830A .NUM		\ print whole number
					"." EMIT		\ print decimal point
					#100 * #16 /		\ turn binary bits to 100ths
					$020A .NUM		\ print decimal
					."  degrees C  " CR
					;

: T1 SKIPROM CONVERTT #750 ms GETTEMP .S PRINTTEMP .S ;

END

